import sys
import time
import socket
import esp
import network
import gc

def dl():
    import uhashlib
    import ubinascii

    addr = ("10.0.0.171", 8080)
    s = socket.socket()
    s.settimeout(10)
    old_k = 0
    try:
        s.connect(addr)
        s.write(b"GET\r\n")
        size = 0
        hash = uhashlib.sha1()
        t = time.ticks_ms()
        while 1:
            buf = s.read(1024)
            if buf == b"": break
            hash.update(buf)
            size += len(buf)
            new_k = size >>20
            if new_k != old_k:
                sys.stdout.write("%dM " % (size >> 20))
                old_k = new_k
        delta = time.ticks_diff(time.ticks_ms(), t)
        #print()
        print("\nSize :", size)
        print("Speed: %s bytes/s" % (size / delta * 1000))
        print("Elapsed: %s" % (delta / 1000))
        sha = str(ubinascii.hexlify(hash.digest()), "ascii")
        print("SHA1 :", sha)
        return size, sha
    finally:
        s.close()

def main():
    total = 0
    fails = 0
    while 1:
        try:
            size, sha = dl()
        except OSError as e:
            sys.print_exception(e)
            print("ESP bufs: tx:%d rx:%d" % (esp.esf_free_bufs(0), esp.esf_free_bufs(4)))
            fails += 1
            time.sleep(2)
            continue
        total += size
        print("Total downloaded so far: %dM" % (total >> 20))

main()

